local AtonementTracker = _G.AtonementTracker

local slash_cmd = {}
AtonementTracker.slash_cmd = slash_cmd
-- Setup Slash Commands
SLASH_ATONEMENTTRACKER1, SLASH_ATONEMENTTRACKER2 = '/ato', '/atonement'

function SlashCmdList.ATONEMENTTRACKER(msg, editbox) -- 4.
	local command, rest = msg:match("^(%S*)%s*(.-)$");
	command = string.lower( command )
	if command == "" or command == "info" or command == "help" then
		slash_cmd:DisplayHelp()
	elseif command == "scale" then
		slash_cmd:ScaleUi( rest )
	elseif command == "c" or command == "compact" then
		slash_cmd:ToggleCompact( rest )
	elseif command == "position" or command == "pos" then
		slash_cmd:PositionUi( rest )
	elseif command == "order" or command == "o" then
		slash_cmd:SetOrder( rest )
	elseif command == "health" then
		slash_cmd:HealthDisplay( rest )
	end
	
end

function slash_cmd:DisplayHelp()
	DEFAULT_CHAT_FRAME:AddMessage( "Atonement Tracker Slash Commands", 1, 1, 0.444 )
	DEFAULT_CHAT_FRAME:AddMessage( "====================================", 1,1,1 )
	DEFAULT_CHAT_FRAME:AddMessage( "/ato, /ato info, /ato help - This Menu", 1,1,1 )
	DEFAULT_CHAT_FRAME:AddMessage( "/ato scale # - Sets the scale of the AtonementTracker frame", 1,1,1 )
	DEFAULT_CHAT_FRAME:AddMessage( "/ato compact - Toggles use of the compact frame", 1,1,1 )
	DEFAULT_CHAT_FRAME:AddMessage( "/ato order (asc or desc) - Sets the sort order on the full frame.", 1,1,1 )
	DEFAULT_CHAT_FRAME:AddMessage( "/ato health (off or on) - Sets the display of the health percentage on the full frame", 1,1,1 )
end

function slash_cmd:ScaleUi( rest )
	local value = tonumber( rest )
	if not value or value < 0.1 then
		DEFAULT_CHAT_FRAME:AddMessage( "Please specify a valid number for the ui scale", 1,1,1 )
		DEFAULT_CHAT_FRAME:AddMessage( "/ato scale # - Sets the scale of the AtonementTracker frame", 1,1,1 )
	end
	AtonementTracker.ui:Scale( value )
end

function slash_cmd:ToggleCompact( rest )
	AtonementTracker.ui:ToggleCompact()
end

function slash_cmd:PositionUi( rest )
	local x_str, y_str = rest:match("^(%S*)%s*(.-)$");
	local x = tonumber( x_str ) or 1
	local y = tonumber( y_str ) or 1
	AtonementTracker.ui:SetPosition( x, y )
end

function slash_cmd:SetOrder( rest )
	local order, rest = rest:match("^(%S*)%s*(.-)$");
	if AtonementTrackerDB then
		if order == "ascending" or order == "asc" then
			AtonementTrackerDB.sort = 'asc'
		else
			AtonementTrackerDB.sort = 'desc'
		end
	end
end

function slash_cmd:HealthDisplay( rest )
	local cmd, rest = rest:match("^(%S*)%s*(.-)$");
	if AtonementTrackerDB then
		if cmd == "off" then
			AtonementTrackerDB.hide_health_pct = true
		else
			AtonementTrackerDB.hide_health_pct = false
		end
	end
end